* OPEN CODE oF MADforWATER PROJECT       Contract no. 688320
*DevelopMent AnD application of integrated technological and management solutions FOR
*wasteWATER treatment and efficient reuse in agriculture tailored to the needs of Mediterranean African Countries

* Copyright (C) <2020> <Alessandra Scardigno, Consuelo Varela-Ortega, Najib Boubakri, Irene Blanco-Gutirrez>
* This is the program "MADFORWATER. Decision Support Tool for wastewater
* management and for water & land management in agriculture", licensed
* under the GNU General Public License v3.0 (see file LICENSE.txt).



SET

C crops     / Clementine, Navel, Maroc_Late, Nour, Nadorcott, tomato_int, tomato_ext, pepper_int, pepper_ext /
CS(c) crops / Clementine, Navel, Maroc_Late, Nour, Nadorcott, pepper_int, pepper_ext /
CW(c) crops / Clementine, Navel, Maroc_Late, Nour, Nadorcott, tomato_int, tomato_ext  /
********************************************************************************
*List of the crops cultivate and cultivable in the area.
********************************************************************************
T  methods       /  t1   /
********************************************************************************
*List of used and/usable irrigation methods /(full, deficit, etc)
********************************************************************************
P field sections /c_land /
********************************************************************************
*List of the sections or parcels into which your area can be divided
********************************************************************************
Q water quality  /q1,q2/
********************************************************************************
*List of available qulity/source of irrigation water (i.e.freshwater, treated wastewater)
********************************************************************************
F fertiliser     /f1,f2/
********************************************************************************
*List of  used/usable fertiliser    (i.e. ammonitrate, monoammonium phosphate, etc)
********************************************************************************
I irrigation techniques  /drip /
********************************************************************************
*List of  used/usable irrigation technologies (i.e. drip, sprinkler, surface, etc.)
********************************************************************************
M       months
/jan1, jan2, feb1,feb2, mar1, mar2, apr1, apr2, may1, may2, jun1,jun2,
jul1, jul2, aug1, aug2, sep1, sep2, oct1, oct2, nov1, nov2, dec1, dec2/
S       season        /sm, wm/
********************************************************************************
*List/s of the timeframe/s   (i.e.bimonthly, monthly, seasonal, etc)
********************************************************************************
SM(m) summer months  /mar1, mar2, apr1, apr2, may1, may2, jun1,jun2, jul1, jul2, aug1, aug2, sep1, sep2/
WM(m) winter months / oct1, oct2, nov1, nov2, dec1, dec2,jan1, jan2, feb1,feb2/
********************************************************************************
*List of the grouped timeframe: this a subset on  'm'
********************************************************************************
Kp    random prices   /kp1*kp5/
Ky    random yields   /ky1*ky5/
********************************************************************************
*Number of the states to generate the random prices and yields
********************************************************************************


PARAMETER

phi        risk aversion_coefficient
/0/

el_pr      price elasticity
/0.957/

landf(p)   available land
/c_land 47592/

eff(i,q)   application efficiency of irrigation methods
/drip.q1  0.95 , drip.q2   0.95/

WATPR (q)  price of water   (euro per cubic meter)
 /q1 1.5, q2  1.5   /

fertpr (f)  price of the fertilisers     (euro per kg)
/f1  0.32 , f2   0.89  /

pr (c)    price of the crop (euro per 1000kg)
/Clementine 280, Navel 380, Maroc_Late 356, Nour 304, Nadorcott 440, tomato_int 350, tomato_ext 300, pepper_int 380, pepper_ext 360/

pr_dev (c)  Coefficient of variation of croprs price
/Clementine 22, Navel 10, Maroc_Late 20, Nour 0, Nadorcott  35, tomato_int 20, tomato_ext 10, pepper_int 20, pepper_ext 15/

sub_lev(q)   percentage of technology cost subsidised
/q1    0,     q2    0.5   /
;

TABLE    L_use (c,m)    Land use (yes or no)
          jan1 jan2 feb1 feb2 mar1 mar2 apr1 apr2 may1 may2 jun1 jun2 jul1 jul2 aug1 aug2 sep1 sep2 oct1 oct2 nov1 nov2 dec1 dec2
Clementine   1   1   1    1    1    1    1   1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1
Navel        1   1   1    1    1    1    1   1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1
Maroc_Late   1   1   1    1    1    1    1   1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1
Nour         1   1   1    1    1    1    1   1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1
Nadorcott    1   1   1    1    1    1    1   1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1    1
tomato_int   1   1   1    1    1    1    0   0    0    0    0    0    0    0    0    0    0    0    1    1    1    1    1    1
tomato_ext   1   1   1    1    1    1    0   0    0    0    0    0    0    0    0    0    0    0    1    1    1    1    1    1
pepper_int   0   0   0    0    0    0    1   1    1    1    1    1    1    1    1    1    1    1    0    0    0    0    0    0
pepper_ext   0   0   0    0    0    0    1   1    1    1    1    1    1    1    1    1    1    1    0    0    0    0    0    0
********************************************************************************
*Table of the  possible combination beetween crop and period of cultivation
*Put 1 if the crop is cultivate in a specific month
*Put 0 if not
********************************************************************************

TABLE    Combi1 (c,i,t,p)
                         c_land
Clementine.  drip.t1        1
Navel     .  drip.t1        1
Maroc_Late . drip.t1        1
Nour        .drip.t1        1
Nadorcott   .drip.t1        1
tomato_int.  drip.t1        1
tomato_ext.  drip.t1        1
pepper_int.  drip.t1        1
pepper_ext.  drip.t1        1
********************************************************************************
*Table of the  possible combination beetween crop and period of cultivation
*Put 1 if the crop is cultivate in a specific month
*Put 0 if not
********************************************************************************

TABLE  nir (c,t,m)        Net irrigation requirements (m3 per ha)
                jan1   jan2  feb1   feb2   mar1    mar2   apr1  apr2   may1   may2  jun1      jun2    jul1    jul2    aug1     aug2    sep1    sep2     oct1     oct2    nov1        nov2        dec1    dec2
Clementine. t1    14    14   24     21     24      26      28     28    32     34    33        48      37      40      32       34      16      16       13       14      14          14          9      13
Navel .     t1    14    15   23     20     23      25      31     31    31     33    32        46      46      49      41       43      23      23       19       22      21          21          8      12
Maroc_Late. t1    14    15   26     23     26      28      35     35    35     38    37        53      53      56      47       50      24      24       19       22      21          21          8      13
Nour.       t1    13    14   24     21     24      26      28     28    32     34    29        42      33      35      28       30      16      16       13       15      14          14          8      13
Nadorcott.  t1    27    28    9      7     22      35      40     45    52     63    65        51      60      76      74       80      76      74       49       45      35          17          4      18
tomato_int. t1    50    50   60     60     60      60      0      0     0      0     0         0       0       0       0        0       0       0        55       55      55          50          50     50
tomato_ext. t1    40    40   50     50     55      50      0      0     0      0     0         0       0       0       0        0       0       0        50       50      50          45          45     45
pepper_int. t1    0     0    0      0      0       0       40     40    45     45    50        50      55      55      55       55      50      50       0        0       0           0           0      0
pepper_ext. t1    0     0    0      0      0       0       36     36    40     44    47        47      53      54      55       55      48      48       0        0       0           0           0      0
;
********************************************************************************
*Table of the NIR for each crop in each period
********************************************************************************

TABLE fertreq(c,q,f)    Fertiliser requirements (kg per ha)
                        f1        f2
Clementine .  q1        570        68
Navel      .  q1        603        77
Maroc_Late .  q1        612        78
Nour       .  q1        571        65
Nadorcott  .  q1        558        73
Clementine .  q2        114        48
Navel      .  q2        120        54
Maroc_Late .  q2        122        55
Nour       .  q2        114        46
Nadorcott  .  q2        111        51
tomato_int .  q1        700        100
tomato_int .  q2        300        60
tomato_ext .  q1        650        90
tomato_ext .  q2        220        50
pepper_int .  q1        550        90
pepper_int .  q2        230        55
pepper_ext .  q1        210        60
pepper_ext .  q2        180        50
********************************************************************************
*Table of the fertiliser for each crop and each different water quality
********************************************************************************
TABLE   y  (c,q,t)    (yields ton per ha)
                     T1
Clementine.  q1      30
Clementine.  q2      30
Nadorcott .  q1      65
Nadorcott .  q2      65
Navel     .  q1      40
Navel      . q2      40
Maroc_Late . q1      45
Maroc_Late . q2      45
Nour        .q1      40
Nour        .q2      40
tomato_int.  q1      50
tomato_int.  q2      50
tomato_ext.  q1      30
tomato_ext.  q2      30
pepper_int.  q1      40
pepper_int.  q2      40
pepper_ext.  q1      28
pepper_ext.  q2      28
;
********************************************************************************
*Table of the yields per crop, different water quality and technique
********************************************************************************
TABLE    y_dev (c,q,t)  (% of variation of random yields)
                     T1
Clementine.  q1      29
Clementine.  q2      29
Nadorcott .  q1      52
Nadorcott .  q2      52
Navel     .  q1      29
Navel      . q2      29
Maroc_Late . q1      51
Maroc_Late . q2      51
Nour        .q1      36
Nour        .q2      36
tomato_int.  q1      32
tomato_int.  q2      32
tomato_ext.  q1      20
tomato_ext.  q2      20
pepper_int.  q1      18
pepper_int.  q2      18
pepper_ext.  q1      15
pepper_ext.  q2      15
;
********************************************************************************
*Coefficient of Variation of Crops yields
********************************************************************************
TABLE    vc(c,q)        variable cost (euro per ha)
                   q1         q2
Clementine       3042.2     3042.2
Navel            3105.6     3105.6
Maroc_Late       3105.6     3105.6
Nour             3105.6     3105.6
Nadorcott        3042.2     3042.2
tomato_int       3200       3200
tomato_ext       3100       3100
pepper_int       3000       3000
pepper_ext       2800       2800
********************************************************************************
*Cariable cost of cultivations
********************************************************************************
TABLE   tech_cost(c,q)     cost of technology (euro per ha)
               q1    q2
Clementine      0   350
Navel           0   350
Maroc_Late      0   350
Nour            0   350
Nadorcott       0   350
tomato_int      0   350
tomato_ext      0   350
pepper_int      0   350
pepper_ext      0   350


TABLE iniarea(c,p)        observed cropping patten (ha)
               c_land
Clementine      12527
Navel            4750
Maroc_Late       8981
Nour             4840
Nadorcott        1194
tomato_int       5000
tomato_ext       3300
pepper_int       5000
pepper_ext       2000
;


TABLE       watsup(p,q,s)    water vailability (m3 per ha)
                sm        wm
c_land.   q1    800        800
c_land .  q2    800        800
********************************************************************************
*Amount of available water per season aand per different quality
********************************************************************************
;

PARAMETER
GIR (c,i,t,m,q)  Gross irrigation requirements (m3 per ha) ;
GIR(c,i,t,m,q)=(NIR(c,t,m)/eff(i,q));
PARAMETER
Pr_k (c,kp)      Random prices    ;
pr_k(c,kp)  =normal(pr(c),pr_dev(c))     ;
PARAMETER
Y_k (c,q,t,ky)   Random yields  ;
y_k(c,q,t,ky) = normal(y(c,q,t),y_dev(c,q,t))  ;

PARAMETER
fertreq          Fertiliser requirement
fertpr(f)        Fertiliser price
IniArea (c,p)    Current cropping pattern
watsup           Water supply (m3)
landf (p)        yavailable land per section
watpr (q)      price of water
eff(i,q)         efficiency of irrigation tech
combi1           possible combination between crop and technique
tech_cost (c,q)  cost of technology
calibr           calibration index
;

VARIABLE
U             Utility function
ZK(ky,kp,p)   Random Income
sigma (p)     Standard   deviation
GRMARG        Gross margin
GRMARG_k      Random gross margin
fertused      Amount of fertiliser applied
diff          Difference between observed and actual cropping patttern
techamount    Area with the new technology (ha)
;

POSITIVE VARIABLE
X(c,i,q,t,p)   Crop activity level (ha)
Z              Expected income (euro)
watreqc        Water demand
pricewat       Cost of water
varcosts       Variable cost
tot_cost_wat   Cost of water
;


EQUATION
objective
income_e
income_k
std_dev
differ
gm
gm_k
fland
suwatfs1
suwatfw1
suwatfs2
suwatfw2
water_totcs1
water_totcs2
water_totcw1
water_totcw2
swater_totc
swater_tot_tot_c
fert_tot
tech_amount
var_costs
;

objective..              U =e=  Z('c_land') - phi* SIGMA('c_land')  ;

differ(c).. diff(c) =e=    ((sum((i,q,t,p), X(c,i,q,t,p)$Combi1(c,i,t,p)))  -    (sum((p),(Iniarea(c,p)))))/( sum ((p),(Iniarea(c,p)))) ;

GM(c,t,q,p)..        (Y(c,q,t)     *(Pr(c)-Pr(c)*0.957*diff(c)))           - tech_cost(c,q)*sub_lev(q) - vc(c,q)  -sum (f, fertreq(c,q,f)*fertpr(f))  =e= GRMARG(c,q,t,p);
GM_k(c,q,t,p,ky,kp)..(Y_k(c,q,t,ky)*(Pr_k(c,kp)-Pr_k(c,kp)*0.957*diff(c))) - tech_cost(c,q)*sub_lev (q)- vc(c,q)  -sum (f, fertreq(c,q,f)*fertpr(f))  =e= GRMARG_k(c,q,t,p,ky, kp)  ;


income_e(p)..        Z(p)        =e=  (sum((c,q,t,i),GRMARG(c,q,t, p)       *X(c,i,q,t,p))- tot_cost_wat(p) );
income_k(ky,kp,p)..  Zk(ky,kp,p) =e=  (sum((c,q,t,i), GRMARG_k(c,q,t,p,ky,kp)*X(c,i,q,t,p))  - tot_cost_wat(p)) ;

std_dev(p)..         SIGMA (p) =e= sqrt(sum ((ky,kp), sqr(ZK(ky, kp,p)-Z(p)))/(card (Kp)*card (ky)));

fert_tot(f,q)..            sum ((c,i,t,p), fertreq(c,q,f)*X(c,i,q,t,p)) =e= fertused(f,q)    ;
tech_amount(q)..           sum ((c,i,t,p), tech_cost(c,q)*X(c,i,q,t,p)) =e= techamount(q)    ;
var_costs (c,q)..          sum ((i,t,p), vc(c,q)*X(c,i,q,t,p)) =e= varcosts (c,q)   ;

swater_tot_tot_c (p)..     tot_cost_wat(p)=e= sum ((c,q),pricewat(p,q,c));
swater_totc (p,q,c)..      watreqc(p,q,c)*watpr(q) =e= pricewat(p,q,c);

fland(p,m)..               sum((c,i,t,q), X(c,i,q,t,p))  =e=    landf(p)  ;

water_totcs1 (p,'q1',cs).. sum((i,t,m), gir(cs,i,t,m,'q1') * X(cs,i,'q1',t,p)$Combi1(cs,i,t,p)*L_use(cs,m) )=e=watreqc(p,'q1',cs);
water_totcs2 (p,'q2',cs).. sum((i,t,m), gir(cs,i,t,m,'q2') * X(cs,i,'q2',t,p)$Combi1(cs,i,t,p)*L_use(cs,m) )=e=watreqc(p,'q2',cs);
water_totcw1 (p,'q1',cw).. sum((i,t,m), gir(cw,i,t,m,'q1') * X(cw,i,'q1',t,p)$Combi1(cw,i,t,p)*L_use(cw,m) )=e=watreqc(p,'q1',cw);
water_totcw2 (p,'q2',cw).. sum((i,t,m), gir(cw,i,t,m,'q2') * X(cw,i,'q2',t,p)$Combi1(cw,i,t,p)*L_use(cw,m) )=e=watreqc(p,'q2',cw);

suwatfs1(p,'q1','sm')..    sum(cs,watreqc(p,'q1',cs)) =l= watsup(p,'q1','sm')*landf (p) ;
suwatfs2(p,'q2','sm')..    sum(cs,watreqc(p,'q2',cs)) =l= watsup(p,'q2','sm')*landf (p) ;

suwatfw1(p,'q1','wm')..    sum(cw,watreqc(p,'q1',cw))  =l=watsup(p,'q1','wm')*landf (p) ;
suwatfw2(p,'q2','wm')..    sum (cw,watreqc(p,'q2',cw))=l= watsup(p,'q2','wm')*landf (p) ;



MODEL general regional gams model / objective,income_e,
income_k,  std_dev, gm,  differ, gm_k, fland,  suwatfs1, suwatfw1,suwatfs2, suwatfw2,water_totcs1,water_totcs2, water_totcw1,
water_totcw2, swater_totc , swater_tot_tot_c,fert_tot, tech_amount, var_costs /  ;


SOLVE general using NLP maximizing U

PARAMETER
RES_RES (*,*,*),
res_CROP (*,*,*,*,*)
;

OPTION RES_CROP:3:4:1;
OPTION RES_RES :0:0:3;

RES_RES ('LANDT','tot','tot')  =   sum((c,i,t,p,q), (X.l(c,i,q,t,p)))    ;
RES_RES ('LAND','tot',q)  =   sum((c,i,t,p), X.l(c,i,q,t,p))    ;
RES_RES('crop', c, q) = sum ((i,t,p),X.l(c,i,q,t,p)) ;
RES_RES ('WATq1',p,c)= watreqc.l(p,'q1',c)    ;
RES_RES ('WATq2',p,c)= watreqc.l(p,'q2',c)    ;
RES_RES('fert', q,f)  = fertpr(f)*fertused.l(f,q);
RES_RES ('util', 'tot', 'obj')= u.l;
RES_RES ('inc', 'tot', p)= z.l(p);
RES_RES ('dev', 'tot', p)= sigma.l(p);
RES_RES ('INC_ha', 'tot', 'obj')= u.l/RES_RES ('LANDT','tot','tot');
RES_RES('WATPRICE','tot',p)= tot_cost_wat.l(p) ;
RES_RES ('SUBSIDIES', 'tec',q)=     techamount.l(q) *sub_lev(q)  ;

RES_RES ('calC2','tot','index' )=  sum (c, ((sum (p, iniarea (c,p))- sum((i, q, t, p), X.l(c,i,q,t,p)))/(sum(p,iniarea(c,p))))*100 ) ;

RES_CROP(c, i, q, t, p) = X.l(c,i,q,t,p) ;
RES_CROP(c,q,f, 'fert', 'quant')=    fertreq(c,q,f)*        Sum ((i,t,p),X.l(c,i,q,t,p) ) ;
RES_CROP(c,q,'var', 'cost', 'varcosts')=  varcosts.l (c,q) ;
RES_CROP (c,i,t,m,q) = GIR (c,i,t,m,q);


DISPLAY res_res

;